unit CustomQueryDesigner;
(*
********************************************************************************
*
*  CustomQueryDesigner v0.9 beta by vb 2001
*
*  comments, questions welcomed to vb@pannon-viz.hu
*
*  Licence : freeware, no warrianty, no responsibility, use your own risk
*
********************************************************************************
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Contnrs,
  IniFiles, Registry, comctrls, IBDatabase, IBHeader, Ibquery, DB,
  CustomQueryDesignerTypes;

resourcestring
  errInvalidQFilestructure = 'Invalid query file structure.';
  errInvalidCFileStructure = 'Invalid cache file structure.';
  errTableNameMissing      = 'Tablename missing.';
  errViewsMissing          = 'Both TreeView and ListView must be set';
  errDiffFieldCountInIndex = 'Diferrent field count in indexes';

  SLBColNameFieldName      = 'Field name';
  SLBColNameValue          = 'Value';

type
  TTypeMask = packed record
    TypeID : smallint;
    Mask   : string;
  end;

  TTypeMaskArray = array [0..13] of TTypeMask;

  TFieldBoolOperators = (fboNOTASSIGNED, fboAND, fboOR, fboANDNOT, fboORNOT, fboCONTAINING, fboSTARTINGWITH );

  TFieldValueExpression = packed record
    HasValue        : boolean;
    Operator        : TFieldValueOperators;
    ValueAsText     : string;
  end;

  TOnFieldValueRequired = procedure ( Sender : TObject;
                                      Table,
                                      FieldName,
                                      FieldDisplayName : string;
                                      DataType  : TFieldType;
                                      StrLength : integer;
                                      var MainBool,
                                          BoolBetweenFields : TFieldBoolOperators;
                                      var FieldLowValue,
                                          FieldHighValue : TFieldValueExpression;
                                      var ClearValues : boolean ) of object;

const

  CAHCE_FILE_ID             = 'CQD'#255;
  CACHE_FILE_EXTENSION      = 'cqd';
  CACHE_FILES               = '*.'+CACHE_FILE_EXTENSION;
  CACHE_FILE_NAME_SEPARATOR = '@';
  QUERY_FILE_EXTENSION      = 'qry';

  IB_SMALLINT  =   7;
  IB_INTEGER   =   8;
  IB_QUAD      =   9;
  IB_FLOAT     =  10;
  IB_D_FLOAT   =  11;
  IB_DATE      =  12;
  IB_TIME      =  13;
  IB_CHAR      =  14;
  IB_INT64     =  16;
  IB_DOUBLE    =  27;
  IB_TIMESTAMP =  35;
  IB_VARCHAR   =  37;
  IB_CSTRING   =  40;
  IB_BLOB      = 261;

  TypeMask : TTypeMaskArray = (( TypeID : IB_SMALLINT;  Mask : '99999;0; ';),
                               ( TypeID : IB_INTEGER;   Mask : '99999999;0; '),
                               ( TypeID : IB_QUAD;      Mask : '99999;; '),
                               ( TypeID : IB_FLOAT;     Mask : '9999999.99;1; '),
                               ( TypeID : IB_D_FLOAT;   Mask : '9999999.99;1; '),
                               ( TypeID : IB_DATE;      Mask : '9999.99.99;1; '),
                               ( TypeID : IB_TIME;      Mask :  '99:99:99;1; '),
                               ( TypeID : IB_CHAR;      Mask : ''),
                               ( TypeID : IB_INT64;     Mask : '99999999;0; '),
                               ( TypeID : IB_DOUBLE;    Mask : '9999999.99;1; '),
                               ( TypeID : IB_TIMESTAMP; Mask : '9999.99.99;1; '),
                               ( TypeID : IB_VARCHAR;   Mask : ''),
                               ( TypeID : IB_CSTRING;   Mask : ''),
                               ( TypeID : IB_BLOB;      Mask : ''));

  (*
  SQL_Relations = 'SELECT C.RDB$RELATION_NAME  AS DETAIL_TABLE,'+#13+
                  '        MasterIndex.RDB$RELATION_NAME AS MASTER_TABLE,'+#13+
                  '        DetailIndex.RDB$INDEX_NAME AS DETAIL_INDEX,'+#13+
                  '        MasterIndex.RDB$INDEX_NAME AS MASTER_INDEX'+#13+
                  'FROM RDB$RELATION_CONSTRAINTS C'+#13+
                  'INNER JOIN RDB$INDICES DetailIndex ON DetailIndex.RDB$INDEX_NAME=C.RDB$INDEX_NAME'+#13+
                  'INNER JOIN RDB$INDICES MasterIndex ON MasterIndex.RDB$INDEX_NAME=DetailIndex.RDB$FOREIGN_KEY'+#13+
                  'WHERE RDB$CONSTRAINT_TYPE=''FOREIGN KEY'' AND'+#13+
                  '      C.RDB$RELATION_NAME = :TableName AND'+#13+
                  '      MasterIndex.RDB$RELATION_NAME <> :ExcludeTable'+#13+
                  'ORDER BY C.RDB$RELATION_NAME, MasterIndex.RDB$RELATION_NAME';
  *)

  SQL_Relations = 'SELECT C.RDB$RELATION_NAME  AS DETAIL_TABLE,'+#13+
                  '        MasterIndex.RDB$RELATION_NAME AS MASTER_TABLE,'+#13+
                  '        DetailIndex.RDB$INDEX_NAME AS DETAIL_INDEX,'+#13+
                  '        MasterIndex.RDB$INDEX_NAME AS MASTER_INDEX'+#13+
                  'FROM RDB$RELATION_CONSTRAINTS C'+#13+
                  'INNER JOIN RDB$INDICES DetailIndex ON DetailIndex.RDB$INDEX_NAME=C.RDB$INDEX_NAME'+#13+
                  'INNER JOIN RDB$INDICES MasterIndex ON MasterIndex.RDB$INDEX_NAME=DetailIndex.RDB$FOREIGN_KEY'+#13+
                  'WHERE RDB$CONSTRAINT_TYPE=''FOREIGN KEY'' AND'+#13+
                  '      C.RDB$RELATION_NAME = :TableName AND'+#13+
                  '      ( MasterIndex.RDB$RELATION_NAME NOT IN ( %s ) )'+#13+
                  'ORDER BY C.RDB$RELATION_NAME, MasterIndex.RDB$RELATION_NAME';


  SQL_DetailForeingkey = 'SELECT C.RDB$RELATION_NAME  AS DETAIL_TABLE,'+#13+
                         '       MasterIndex.RDB$RELATION_NAME AS MASTER_TABLE,'+#13+
                         '       DetailIndex.RDB$INDEX_NAME AS DETAIL_INDEX,'+#13+
                         '       MasterIndex.RDB$INDEX_NAME AS MASTER_INDEX'+#13+
                         'FROM RDB$RELATION_CONSTRAINTS C'+#13+
                         'INNER JOIN RDB$INDICES DetailIndex ON DetailIndex.RDB$INDEX_NAME=C.RDB$INDEX_NAME'+#13+
                         'INNER JOIN RDB$INDICES MasterIndex ON MasterIndex.RDB$INDEX_NAME=DetailIndex.RDB$FOREIGN_KEY'+#13+
                         'WHERE RDB$CONSTRAINT_TYPE=''FOREIGN KEY'' AND'+#13+
                         'C.RDB$RELATION_NAME= :TableName AND'+#13+
                         'MasterIndex.RDB$RELATION_NAME = :MasterTable'+#13+
                         'ORDER BY C.RDB$RELATION_NAME, MasterIndex.RDB$RELATION_NAME';

  SQL_FieldsInIndex = 'SELECT RDB$FIELD_NAME AS FIELD_NAME,'+#13+
                      '       RDB$FIELD_POSITION AS FIELD_POSITION'+#13+
                      'FROM RDB$INDEX_SEGMENTS'+#13+
                      'WHERE RDB$INDEX_NAME = :Index'+#13+
                      'ORDER BY RDB$FIELD_POSITION';


  SQL_FieldsForTable = 'SELECT RDB$RELATION_FIELDS.RDB$FIELD_NAME as FieldName, RDB$FIELD_TYPE as FieldType,'+#13+
                       '       RDB$CHARACTER_LENGTH as CharLength,'+#13+
                       '       RDB$DESCRIPTION AS Description'+#13+
                       'FROM RDB$RELATION_FIELDS, RDB$FIELDS'+#13+
                       'WHERE RDB$RELATION_FIELDS.RDB$RELATION_NAME = :TableName AND'+#13+
                       '      RDB$FIELD_SOURCE = RDB$FIELD_NAME';

type

  FieldCondition = packed record
    Operator  : TFieldValueOperators;
    HasValue  : boolean;
    Value     : array [0..255] of byte;
  end;

  FieldConditionArray = array [1..2] of FieldCondition;

  (*
   * TQueryValues Structure -> used to save field values in the query
   *)

  TQueryValues = packed record
    TableID           : integer;
    FieldID           : integer;
    Checked           : boolean;
    MainBool          : TFieldBoolOperators;
    BoolBetweenFields : TFieldBoolOperators;
    FieldConditions   : FieldConditionArray;
  end;

  (*
   *  recField & recTable Structures -> used to save the view
   *)

  recField = packed record
    OwnerIndex      : integer;
    Index           : integer;
    FieldName       : string[31];
    DisplayName     : string[128];
    DataType        : integer;
    StrLength       : integer;
    Display         : boolean;
  end;

  recTable = packed record
    TableName   : string[31];
    DetailTable : string[31];
    Index       : string[31];
    DetailIndex : string[31];
    NodeIndex   : integer;
    ListIndex   : integer;
    MasterIndex : integer;
  end;


//******************************************************************************

  TCQField = class(TObject)
  private
    fOwnerIndex : integer;
    fIndex      : integer;

    function BuildExpression() : string;

  public
    FieldName   : string;
    DisplayName : string;
    DataType    : integer;
    StrLength   : integer;
    Expression  : string;
    SQLExp      : string;
    Display     : boolean;
    Checked     : boolean;

    MainBool        : TFieldBoolOperators;
    MainBool2       : TFieldBoolOperators;
    FieldConditions : FieldConditionArray;

    procedure GetFieldAsRecord(var recFld : recField);
    procedure GetFieldAsFieldValueExpression( var FieldValueExpression : TFieldValueExpression;
                                              Index : integer );
    procedure GetFieldFromRecord(recFld : recField);
    function GetFieldData( index : byte ) : string;
    procedure SetFieldData( Value : string; index : byte);

    constructor Create( strFieldName,
                        strDisplayName : string;
                        intDataType,
                        intStrLength : integer;
                        boolDisplay,
                        boolChecked : boolean;
                        Ownerindex,
                        Index : integer );

  end;

  TCQFields = class(TObjectList)
  public
    function FieldByDisplayName( Value : string ) : TCQField;
  end;

  TCQTable = class(TObject)
  public
    TableName   : string;
    DetailTable : string;
    Index       : string;
    DetailIndex : string;
    Displayname : string;
    NodeIndex   : integer;
    ListIndex   : integer;
    Fields      : TCQFields;
    MasterIndex : integer;
    JoinStr     : string;

    procedure GetTableAsRecord( var TblRec : recTable);
    procedure GetTableFromRecord( TblRec : recTable );
    constructor Create( strTableName,
                        strDetailName,
                        strIndex,
                        strDetailIndex : string;
                        intListIndex,
                        intMasterIndex : integer;
                        intNodeIndex : integer );
    destructor Destroy(); override;
  end;


  TCQTables = class(TObjectList)
  private

  public
    function CountOfTableWithSameDetail(TableName, DetailName : string; DetailListIndex : integer) : integer;
    function TableByName( TableName : string) : TCQTable;
    function TableByNodeIndex( Index : integer ) : TCQTable;
    function TableByListIndex( Index : integer ) : TCQTable;
    procedure SortByName();
    procedure SortByNodeIndex();
    procedure SortByListIndex();

  end;

  TCustomQueryDesigner = class(TComponent)
  private
    fIniFile          : TIniFile;
    fRegistry         : TRegistry;
    fParams           : TStringList;
    fSQLSelectFields,
    fSQLSourceTables,
    fSQLWhereClause   : TStringList;

    fTableName        : string;
    fDetailTableName  : string;
    fTreeView         : TTreeView;
    fListView         : TListView;
    fTables           : TCQTables;

    fUpdating          : boolean;
    fAutoSetupListView : boolean;
    fViewGenerated     : boolean;
    fIBDataBase        : TIBDataBase;

    fTransaction       : TIBTransaction;
    fTableRelations    : TIBQuery;
    fDetailForeignKey  : TIBQuery;
    fFieldsInIndex     : TIBQuery;
    fFieldsForTable    : TIBQuery;
    fResultQuery       : TIBQuery;

    fdnsType           : TDisplayNameSourceType;
    fdnsName           : string;

    fUsePermanentCache : boolean;
    fPermanentCacheDir : string;

    fSQLText           : string;

    fIncludeFields     : TStrings;

    fOnFieldValueRequired : TOnFieldValueRequired;

    procedure SetTreeView( Value : TTreeView );
    function GetTreeView() : TTreeView;
    procedure SetListView( Value : TListView );
    function GetListView() : TListView;
    procedure SetTableName( Value : string );
    function GetTableName() : string;
    procedure SetDetailTableName( Value : string );
    function GetDetailTableName() : string;
    procedure SetDisplayNameSource( Value : string );
    function GetDisplayNameSource() : string;
    procedure SetDisplayNameSourceType( Value : TDisplayNameSourceType);
    function GetDisplayNameSourceType() : TDisplayNameSourceType;
    procedure SetIBDataBase( Value : TIBDataBase );
    function GetIBDataBase() : TIBDataBase;
    procedure SetAutoSetupListView( Value : boolean );
    function GetAutoSetupListView() : boolean;
    procedure SetUsePermanentCache( Value : boolean );
    function GetUsePermanentCache() : boolean;
    procedure SetPermanentCacheDir( Value : string );
    function GetPermanentCacheDir() : string;

    procedure SetUpListView();
    function GetMaskForType( TypeID : smallint ) : string;

    procedure AssignDataBaseToQueries();
    procedure PopulateFields( Table : TCQTable );
    procedure DisplayFields( Table : TCQTable );
    procedure IndexFields( IndexName : string; FieldNames : TStringList );
    procedure GetRelatedTable(Name, ExcludeTable : string; Node : TTreeNode; MasterIndex : integer );
    function DetermineJoins( Node : TTreeNode ): boolean;
    procedure BuildJoinString( CQTable : TCQTable );
    function TableHasSelectedFields( CQTable : TCQTable ): integer;

    function GetDisplayOptionsForTable( TableName : string ): string;
    function GetDisplayOptionsForField( TableName, FieldName : string; var Display : boolean ): string; overload;
    function GetDisplayOptionsForField( TableName, FieldName : string ): string; overload;
    procedure SetIncludeFields( Value : TStrings );

    function GetCacheFileName() : string;
    function ViewInCache() : boolean;
    function CheckCacheFileVersion( CacheFile : TFileStream ) : boolean;
    procedure ReadViewFromCache();
    procedure WriteViewToCache();
    procedure WriteFileHeader( FS : TFileStream );

    function PositionToQuery( QueryFile : TFileStream; QueryID : integer; var FieldCount : integer ) : boolean;
    function SeekForDeletedSection( QueryFile : TFileStream ) : boolean;

    function GetField( TableIndex, FieldIndex : integer ) : TCQField;

    function DecomposeIncludeFields() : string;
    function GetFieldCount() : integer;

    function BuildQuery() : string;
    procedure JoinTables();
    function GetMasterTables( Index : integer ) : string;

  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;

  public

    constructor Create( AOwner : TComponent); override;
    destructor Destroy(); override;
    procedure TreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure ListViewChange(Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure ListViewDblClick(Sender: TObject);

    procedure GenereateIniFileStructure( FileName : string = '');
    procedure GenereateRegistryStructure( KeyName : string );

    procedure BuildRelationTree();

    function SetUpResultQuery( Query : TIBQuery ) : boolean;
    procedure CloseView();

    procedure SaveQuery( qryName : shortstring );
    procedure LoadQuery( QueryID : integer );
    procedure DeleteQuery( QueryID : integer );
    procedure GetSavedQueryList( List : TStrings );
    procedure EnumSavedQueries( CallBackProc : TEnumSavedQueries );

    procedure ClearPermanentCache();


//*********
    function TableNameByID( ID : integer ) : string;
    function FieldNameByID( TableID, FieldID : integer ) : string;
    function FieldDisplayNameByID( TableID, FieldID : integer ) : string;

    function SetFieldValue( TableID, FieldID : integer;
                            MainBool,
                            BoolBetweenFields : TFieldBoolOperators;
                            FieldLowValue,
                            FieldHighValue : TFieldValueExpression ) : integer;
//*********

  published
    property TableName : string read GetTableName write SetTableName;
    property DetailTableName : string read GetDetailTableName write SetDetailTableName;
    property TreeView : TTreeView read GetTreeView write SetTreeView;
    property ListView : TListView read GetListView write SetListView;
    property IBDataBase : TIBDataBase read GetIBDataBase write SetIBDataBase;
    property DisplayNameSource : string read GetDisplayNameSource write SetDisplayNameSource;
    property DisplayNameSourceType : TDisplayNameSourceType read GetDisplayNameSourceType write SetDisplayNameSourceType;
    property AutoSetupListView : boolean read GetAutoSetupListView write SetAutoSetupListView;
    property UsePermanentCache : boolean read GetUsePermanentCache write SetUsePermanentCache;
    property PermanentCacheDir : string read GetPermanentCacheDir write SetPermanentCacheDir;
    property OnFieldValueRequired : TOnFieldValueRequired read fOnFieldValueRequired write fOnFieldValueRequired;
    property IncludeFields : TStrings read fIncludeFields write SetIncludeFields;
    property ViewGenerated : boolean read fViewGenerated;
  end;


  EInvalidFileFormat = class(Exception)
  end;

procedure Register;

procedure ClearTrailingSpaces( var Text : string );
procedure ClearLeadingSpaces( var Text : string );

{$R *.res}
implementation



procedure ClearLeadingSpaces( var Text : string );
var i,
    Count : integer;
begin
  i := 1;
  Count := 0;

  while ( i < Length(Text) ) and ( Text[i]=' ' ) do begin
    inc(Count);
    inc(i);
  end;

  if count > 0 then begin
    System.Delete(Text,1,count);
  end;

end;

procedure ClearTrailingSpaces( var Text : string );
var i,
    Count : integer;
begin

  i := Length(Text);
  Count := 0;

  while ( i > 0 ) and ( Text[i]=' ' ) do begin
    dec(i);
    inc(Count);
  end;

  if Count > 0 then begin
    System.Delete(Text,Length(Text)-Count+1, Count);
  end;

end;


(*******************************************************************************
*
* Delete cache files from PermanentCache dir;
*
*)
function ClearCQDCache( DirName : string ) : integer;
var SearchRec : TSearchRec;
begin
  Result := 0;

  if FindFirst( DirName+CACHE_FILES,faAnyfile, SearchRec ) = 0 then begin
    DeleteFile( DirName+SearchRec.Name );
    Inc(Result);

    while FindNext(SearchRec)=0 do begin
      DeleteFile( DirName+SearchRec.Name );
      Inc(Result);
    end;

  end;

  FindClose(SearchRec);

end;

(*******************************************************************************
*
* InterBase DataType conversion to Delphi TFieldType
*
*)
function IBDataTypeToParamType( IBType : smallint ) : TFieldType;
begin

  case IBType of
    IB_SMALLINT  : Result := ftSmallInt;
    IB_INTEGER   : Result := ftInteger;
//    IB_QUAD      : ;
    IB_DOUBLE,
    IB_FLOAT,
    IB_D_FLOAT   : Result := ftFloat;
    IB_DATE      : Result := ftDate;
    IB_TIME      : Result := ftTime;
    IB_INT64     : Result := ftLargeInt;
    IB_TIMESTAMP : Result := ftDateTime;
    IB_CHAR,
    IB_VARCHAR,
    IB_CSTRING   : Result := ftString;
    IB_BLOB      : Result := ftBlob;
  else
   Result := ftUnknown;
  end;

end;


(*******************************************************************************
*
* Sort routine for fTables object
*
*)
function fSortByName(Item1, Item2: Pointer): Integer;
begin
  Result := 1;

  if TCQTable(Item1).TableName < TCQTable(Item2).TableName then begin
    Result := -1;
  end else if TCQTable(Item1).TableName = TCQTable(Item2).TableName then begin
    Result := 0;
  end;

end;


(*******************************************************************************
*
* Sort routine for fTables object
*
*)
function fSortByNodeIndex(Item1, Item2: Pointer): Integer;
begin
  Result := 1;

  if TCQTable(Item1).NodeIndex < TCQTable(Item2).NodeIndex then begin
    Result := -1;
  end else if TCQTable(Item1).NodeIndex = TCQTable(Item2).NodeIndex then begin
    Result := 0;
  end;

end;


(*******************************************************************************
*
* Sort routine for fTables object
*
*)
function fSortByListIndex(Item1, Item2: Pointer): Integer;
begin
  Result := 1;

  if TCQTable(Item1).ListIndex < TCQTable(Item2).ListIndex then begin
    Result := -1;
  end else if TCQTable(Item1).ListIndex = TCQTable(Item2).ListIndex then begin
    Result := 0;
  end;

end;


//******************************************************************************

constructor TCQField.Create( strFieldName,
                             strDisplayName : string;
                             intDataType,
                             intStrLength : integer;
                             boolDisplay,
                             boolChecked : boolean;
                             Ownerindex,
                             Index : integer );
begin
  inherited Create();
  FieldName   := strFieldName;
  DisplayName := strDisplayName;
  DataType    := intDataType;
  StrLength   := intStrLength;
  Expression  := '';
  SQLExp      := '';
  Display     := boolDisplay;
  Checked     := boolChecked;
  fOwnerindex := Ownerindex;
  fIndex      := Index;
end;


function TCQField.BuildExpression() : string;
begin
  Expression := '';

  if FieldConditions[1].HasValue then begin
    Expression := Format('"%s" %s "%s"',[DisplayName, TOperatorList[Ord(FieldConditions[1].Operator)],GetFieldData(1)]);

    SQLExp := Format('%s %s :a_%d_%d',[FieldName, TOperatorList[Ord(FieldConditions[1].Operator)],
                                    fOwnerIndex,fIndex]);
  end;

  if (MainBool2 <> fboNOTASSIGNED) and (FieldConditions[2].HasValue) then begin

    Expression := Expression + Format(' %s "%s" %s "%s"',[TBoolOperators[Ord(MainBool2)], DisplayName,
                                                         TOperatorList[Ord(FieldConditions[2].Operator)],GetFieldData(2)]);

// For Hungarian version
(*
    Expression := Expression + Format(' %s "%s" %s "%s"',[THunBoolOperators[Ord(MainBool2)], DisplayName,
                                                         TOperatorList[Ord(FieldConditions[2].Operator)],GetFieldData(2)]);
*)
    SQLExp := SQLExp +Format(' %s %s %s :b_%d_%d',[TBoolOperators[Ord(MainBool2)],FieldName, TOperatorList[Ord(FieldConditions[1].Operator)],
                                    fOwnerIndex,fIndex]);

  end;

  Result := Expression;

end;


function TCQField.GetFieldData( index : byte ) : string;
begin

  if FieldConditions[index].HasValue then begin

    case DataType of
      IB_SMALLINT  : Result := IntToStr(smallint( pointer(@FieldConditions[index].Value)^ ));
      IB_INTEGER   : Result := IntToStr(integer( pointer(@FieldConditions[index].Value)^ ));
      IB_QUAD      : ;
      IB_DOUBLE,
      IB_FLOAT,
      IB_D_FLOAT   : Result := FloatToStr(double( pointer(@FieldConditions[index].Value)^ ));
      IB_DATE      : Result := DateToStr( TDate( pointer(@FieldConditions[index].Value)^ ));
      IB_TIME      : Result := TimeToStr(TTime( pointer(@FieldConditions[index].Value)^ ));
      IB_INT64     : Result := IntToStr(int64( pointer(@FieldConditions[index].Value)^ ));
      IB_TIMESTAMP : Result := DateTimeToStr(TDateTime( pointer(@FieldConditions[index].Value)^ ));
      IB_CHAR,
      IB_VARCHAR,
      IB_CSTRING   : Result := shortstring(FieldConditions[index].Value);
      IB_BLOB      : ;

    end;

  end else begin
    Result := '';
  end;

end;

procedure TCQField.SetFieldData( Value : string; index : byte);
begin

  FieldConditions[index].HasValue := TRUE;

  try                                  
    case DataType of
      IB_SMALLINT  : smallint( pointer(@FieldConditions[index].Value)^ ):= StrToInt(Value);
      IB_INTEGER   : integer( pointer(@FieldConditions[index].Value)^ ):= StrToInt(Value);
      IB_QUAD      : ;
      IB_DOUBLE,
      IB_FLOAT,
      IB_D_FLOAT   : double( pointer(@FieldConditions[index].Value)^ ):= StrToFloat(Value);
      IB_DATE      : TDate( pointer(@FieldConditions[index].Value)^ ):= StrToDate(Value);
      IB_TIME      : TTime( pointer(@FieldConditions[index].Value)^ ):= StrToTime(Value);
      IB_INT64     : int64( pointer(@FieldConditions[index].Value)^ ):= StrToInt64(Value);
      IB_TIMESTAMP : TDateTime( pointer(@FieldConditions[index].Value)^ ):= StrToDateTime(Value);
      IB_CHAR,
      IB_VARCHAR,
      IB_CSTRING   : shortstring(FieldConditions[index].Value):= shortString(Value);
      IB_BLOB      : ;

    end;

  except on E : EConvertError do
    FieldConditions[index].HasValue := FALSE;
  end;

end;

procedure TCQField.GetFieldAsRecord(var recFld : recField);
begin
  recFld.OwnerIndex      := fOwnerIndex;
  recFld.Index           := fIndex;
  recFld.FieldName       := FieldName;
  recFld.DisplayName     := DisplayName;
  recFld.DataType        := DataType;
  recFld.StrLength       := StrLength;
  recFld.Display         := Display;
end;

procedure TCQField.GetFieldFromRecord(recFld : recField);
begin

  fOwnerIndex     := recFld.OwnerIndex;
  fIndex          := recFld.Index;
  FieldName       := recFld.FieldName;
  DisplayName     := recFld.DisplayName;
  DataType        := recFld.DataType;
  StrLength       := recFld.StrLength;
  Display         := recFld.Display;

end;

procedure TCQField.GetFieldAsFieldValueExpression( var FieldValueExpression : TFieldValueExpression;
                                                   Index : integer );
begin
  FieldValueExpression.HasValue    := FieldConditions[Index].HasValue;
  FieldValueExpression.Operator    := FieldConditions[Index].Operator;
  FieldValueExpression.ValueAsText := GetFieldData( Index );
end;

//******************************************************************************

function TCQFields.FieldByDisplayName( Value : string ) : TCQField;
var i : integer;
begin
  Result := nil;

  i:=0;

  while (i < Count-1) and (Result = nil) do begin

    if Value = (Items[i] as TCQField).DisplayName then begin
      Result := (Items[i] as TCQField);
    end;

    Inc(i);
  end;

end;

//******************************************************************************

constructor TCQTable.Create( strTableName,
                             strDetailName,
                             strIndex,
                             strDetailIndex : string;
                             intListIndex,
                             intMasterIndex : integer;
                             intNodeIndex : integer );
begin
  inherited Create();
  Fields := TCQFields.Create(TRUE);

  TableName   := StringReplace(strTableName,' ','',[rfReplaceAll]);
  DetailTable := StringReplace(strDetailName,' ','',[rfReplaceAll]);
  Index       := StringReplace(strIndex,' ','',[rfReplaceAll]);
  DetailIndex := StringReplace(strDetailIndex,' ','',[rfReplaceAll]);
  NodeIndex   := intNodeIndex;
  MasterIndex := intMasterIndex;
  ListIndex   := intListIndex;
end;

destructor TCQTable.Destroy();
begin
  Fields.Free();
  inherited;
end;

procedure TCQTable.GetTableAsRecord( var TblRec : recTable);
begin

  tblrec.TableName   := TableName;
  tblrec.DetailTable := DetailTable;
  tblrec.Index       := Index;
  tblrec.DetailIndex := DetailIndex;
  tblrec.MasterIndex := MasterIndex;
  tblrec.NodeIndex   := NodeIndex;
  tblrec.ListIndex   := ListIndex;

end;

procedure TCQTable.GetTableFromRecord( TblRec : recTable );
begin

  TableName   := tblrec.TableName;
  DetailTable := tblrec.DetailTable;
  Index       := tblrec.Index;
  MasterIndex := tblrec.MasterIndex;
  DetailIndex := tblrec.DetailIndex;
  NodeIndex   := tblrec.NodeIndex;
  ListIndex   := tblrec.ListIndex;

end;

//******************************************************************************

function TCQTables.TableByName( TableName : string) : TCQTable;
var i : integer;
begin
  Result := nil;
  i:=0;

  while (i < Count ) and ( Result = nil ) do begin

    if UpperCase((Items[i] as TCQTable).TableName) = UpperCase(TableName) then begin
      Result := Items[i] as TCQTable;
    end else begin
      inc(i)
    end;
  end;

end;

function TCQTables.TableByNodeIndex( Index : integer ) : TCQTable;
var i : integer;
begin

  i := 0;
  Result := nil;

  while ( i < Count ) and ( Result = nil ) do begin

    if (Items[i] as TCQTable).NodeIndex = Index then begin
      Result := Items[i] as TCQTable;
    end else begin
      inc(i)
    end;

  end;

end;


function TCQTables.TableByListIndex( Index : integer ) : TCQTable;
var i : integer;
begin

  i := 0;
  Result := nil;

  while ( i < Count ) and ( Result = nil ) do begin

    if (Items[i] as TCQTable).ListIndex = Index then begin
      Result := Items[i] as TCQTable;
    end else begin
      inc(i)
    end;

  end;

end;


function TCQTables.CountOfTableWithSameDetail(TableName,DetailName : string; DetailListIndex : integer) : integer;
var i : integer;
begin

  Result := 0;

  for i:=0 to Count-1 do begin

    Inc(Result, integer( ((Items[i] as TCQTable).TableName = TableName) and
                         ((Items[i] as TCQTable).DetailTable = DetailName ) and
                         ((Items[i] as TCQTable).MasterIndex = DetailListIndex )));

  end;

end;


procedure TCQTables.SortByName();
begin
  Sort(fSortByName);
end;

procedure TCQTables.SortByNodeIndex();
begin
  Sort(fSortByNodeIndex);
end;

procedure TCQTables.SortByListIndex();
begin
  Sort(fSortByListIndex);
end;



//******************************************************************************

constructor TCustomQueryDesigner.Create( AOwner : TComponent);
begin
  inherited;

  fUpdating          := FALSE;
  fAutoSetupListView := FALSE;
  fViewGenerated     := FALSE;
  fListView := nil;
  fTreeView := nil;

  fTransaction := TIBTransaction.Create( Self );

  fTableRelations   := TIBQuery.Create( Self );
  fDetailForeignKey := TIBQuery.Create( Self );
  fFieldsInIndex    := TIBQuery.Create( Self );
  fFieldsForTable   := TIBQuery.Create( Self );
  fResultQuery      := TIBQuery.Create( Self );

  with fTableRelations do begin
    // SQL.Text := SQL_Relations;
    // ParamByName('TableName').DataType := ftString;
    // ParamByName('TableName').ParamType := ptInput;
    // ParamByName('ExcludeTable').DataType := ftString;
    // ParamByName('ExcludeTable').ParamType := ptInput;
    TransAction := fTransaction;
  end;

  with fFieldsForTable do begin
    SQL.Text := SQL_FieldsForTable;
    ParamByName('TableName').DataType := ftString;
    ParamByName('TableName').ParamType := ptInput;
    TransAction := fTransaction;
  end;

  with fFieldsInIndex do begin
    SQL.Text := SQL_FieldsInIndex;
    ParamByName('Index').DataType := ftString;
    ParamByName('Index').ParamType := ptInput;
    TransAction := fTransaction;
  end;

  with fDetailForeignKey do begin
    SQL.Text := SQL_DetailForeingkey;
    ParamByName('TableName').DataType := ftString;
    ParamByName('TableName').ParamType := ptInput;
    ParamByName('MasterTable').DataType := ftString;
    ParamByName('MasterTable').ParamType := ptInput;
    TransAction := fTransaction;
  end;

  fResultQuery.TransAction := fTransaction;

  fSQLSelectFields := TStringList.Create();
  fSQLSourceTables := TStringList.Create();
  fSQLWhereClause  := TStringList.Create();
  fParams          := TStringList.Create();
  fIncludeFields   := TStringList.Create();
  fTables := TCQTables.Create(TRUE);

  fOnFieldValueRequired := nil;
end;

destructor TCustomQueryDesigner.Destroy();
begin

  fTableRelations.Close();
  fDetailForeignKey.Close();
  fFieldsInIndex.Close();
  fFieldsForTable.Close();

  fTableRelations.Free();
  fDetailForeignKey.Free();
  fFieldsInIndex.Free();
  fFieldsForTable.Free();

  fIncludeFields.Free();
  fSQLSelectFields.Free();
  fSQLSourceTables.Free();
  fSQLWhereClause.Free();

  fIBDataBase := nil;

  fParams.Free();
  fTransaction.Free();

end;

procedure TCustomQueryDesigner.SetTreeView( Value : TTreeView );
begin

  if fTreeView <> Value then begin

    if Assigned(fTreeView) then begin
      fTreeView := nil;
    end;

    fTreeView := Value;

    if not (csDesigning in ComponentState) then begin
      FTreeView.OnChange := TreeViewChange;
    end;

  end;

end;

function TCustomQueryDesigner.GetTreeView() : TTreeView;
begin
  Result := fTreeView;
end;

procedure TCustomQueryDesigner.SetListView( Value : TListView );
begin

  if fListView <> Value then begin

    if Assigned(fListView) then begin
      fListView := nil;
    end;

    fListView := Value;

    if fAutoSetUpListView then begin
      SetUpListView();
    end;

    if not (csDesigning in ComponentState) then begin
      fListView.OnDblClick := ListViewDblClick;
      fListView.OnChange := ListViewChange;
    end;

  end;

end;

function TCustomQueryDesigner.GetListView() : TListView;
begin
  Result := fListView;
end;

procedure TCustomQueryDesigner.Notification(AComponent: TComponent; Operation: TOperation);
begin

  inherited Notification(AComponent,Operation);

  if (Operation=opRemove) then begin

    if (AComponent = fTreeView) then begin
      fTreeView := nil;
    end else if (AComponent = fListView) then begin
      fListView := nil;
    end else if (AComponent = fIBDataBase) then begin
      fIBDataBase := nil;
    end;

  end;


end;


procedure TCustomQueryDesigner.SetTableName( Value : string );
begin

  if fTableName <> Value then begin
    fTableName := Value;
    fincludeFields.Clear();
  end;

end;

function TCustomQueryDesigner.GetTableName() : string;
begin
  Result := fTableName;
end;

procedure TCustomQueryDesigner.SetDetailTableName( Value : string );
begin

  if fDetailTableName <> Value then begin
    fDetailTableName := Value
  end;
end;

function TCustomQueryDesigner.GetDetailTableName() : string;
begin
  Result := fDetailTableName;
end;

procedure TCustomQueryDesigner.TreeViewChange(Sender: TObject; Node: TTreeNode);
var Tbl : TCQTable;
begin

  if Node <> nil then begin

    Tbl := fTables.TableByNodeIndex(Node.AbsoluteIndex);

    if Tbl.Fields.Count = 0 then begin
      PopulateFields(Tbl);
    end;

    DisplayFields(Tbl);

  end;

end;

procedure TCustomQueryDesigner.CloseView();
var i : integer;
begin

  if fViewGenerated then begin

    for i := 0 to fTables.Count-1 do begin
      (fTables[i] as TCQTable).Fields.Clear();
    end;
    fTables.Clear();

  end;

  fViewGenerated := FALSE;
  
end;

procedure TCustomQueryDesigner.BuildRelationTree();
var CNode : TTreeNode;
    TableCount :integer;
begin

  if Assigned(fTreeView) and Assigned(fListView) then begin

    CloseView();

    if fTableName <> '' then begin

      fTreeView.Items.BeginUpdate();

      if ViewInCache() then begin
        ReadViewFromCache();
      end else begin

        fTreeView.Items.Clear;


        fTreeView.Items.Add( TTreeNode.Create(fTreeView.Items),
                             GetDisplayOptionsForTable(fTableName) );

        fTables.Add( TCQTable.Create( fTablename,
                                      '',
                                      '',
                                      '',
                                      0,
                                      -1,
                                      0) );

        PopulateFields((fTables[0] as TCQTable));

        GetRelatedTable( fTableName,
                         fTableName,
                         fTreeView.Items.Item[0],
                         0 );

        if fDetailTableName <> '' then begin

          CNode:= fTreeView.Items.AddChildObject( fTreeView.Items.Item[0],
                                                  GetDisplayOptionsForTable(fDetailTableName),
                                                  nil );

          with fDetailForeignKey do begin

            ParamByName('TableName').AsString := UpperCase(fDetailTableName);
            ParamByName('MasterTable').AsString := UpperCase(fTableName);
            Open();

            TableCount := fTables.Count;

            fTables.Add(TCQTable.Create( fDetailTableName,
                                         fTableName,
                                         FieldByName('MASTER_INDEX').AsString,
                                         FieldByName('DETAIL_INDEX').AsString,
                                         TableCount,
                                         0,
                                         CNode.AbsoluteIndex));

            Close();
          end;

          PopulateFields((fTables[fTables.Count-1] as TCQTable));

          GetRelatedTable(fDetailTableName,fTableName,CNode,fTables.Count-1);

        end;

      end;

      if fUsePermanentCache then begin
        WriteViewToCache();
      end;

      fTreeView.Items.EndUpdate();
      fViewGenerated := TRUE;

    end else begin
      raise Exception.Create( errTableNameMissing );
    end;

  end else begin
    raise Exception.Create( errViewsMissing );
  end;

end;

procedure TCustomQueryDesigner.DisplayFields( Table : TCQTable );
var i     : integer;
    CItem : TListItem;
    Field : TCQField;
begin

  if Assigned(fListView) then begin

    fListView.Items.BeginUpdate();
    fUpdating := TRUE;

    for i:=0 to fListView.Items.Count-1 do begin
      fListView.Items[i].Data := nil;
    end;

    fListView.Items.Clear();

    for i := 0 to Table.Fields.Count-1 do begin

      Field := (Table.Fields[i] as TCQField);

      if Field.Display then begin

        CItem := ListView.Items.Add();

        with CItem do begin

          Data    := Field;
          Checked := Field.Checked;

          if Field.DisplayName = '' then begin
            Field.DisplayName := GetDisplayOptionsForField(Table.TableName,Field.FieldName);
          end;

          Caption := Field.DisplayName;
          SubItems.Add(Field.Expression);
        end;

      end;

    end;

    fListView.Items.EndUpdate();
    fUpdating:= FALSE;

  end;

end;

procedure TCustomQueryDesigner.PopulateFields( Table : TCQTable );
var Display     : boolean;
    DisplayName,
    FieldName   : string;
begin

  with fFieldsForTable do begin
    ParamByName('TableName').AsString := UpperCase(Table.TableName);
    Prepare;
    Open();

    while not Eof do begin
      FieldName := StringReplace(FieldByName('Fieldname').AsString,' ','',[rfReplaceAll]);
      Display := TRUE;

      if fdnsType = dnsRDBDescription then begin
        DisplayName := fFieldsForTable.FieldByName('Description').AsString;
      end else begin
        DisplayName := GetDisplayOptionsForField( Table.TableName, FieldName, Display);
      end;

      Table.Fields.Add( TCQField.Create(FieldName,
                                        DisplayName,
                                        FieldByName('FieldType').AsInteger,
                                        FieldByName('CharLength').AsInteger,
                                        Display,
                                        FALSE,
                                        Table.NodeIndex,
                                        Table.Fields.Count));

      Next();
    end;

    Close();
    UnPrepare();
  end;
end;

procedure TCustomQueryDesigner.IndexFields( IndexName : string; FieldNames : TStringList );
begin

  with fFieldsInIndex do begin

    Prepare();
    ParamByName('Index').AsString := IndexName;
    Open();

    while not Eof do begin
      FieldNames.Add(StringReplace(FieldByName('FIELD_NAME').AsString,' ','',[rfReplaceAll]));
      Next();
    end;

    Close();
    UnPrepare();
  end;

end;

function TCustomQueryDesigner.GetMaskForType( TypeID : smallint ) : string;
var i : integer;
begin

  i := 0;
  Result := '' ;

  while (i < High(TypeMask)) do begin

    if TypeMask[i].TypeID = TypeID then begin
      Result := TypeMask[i].Mask;
      i := High(TypeMask)
    end else begin
      inc(i);
    end;

  end;

end;

function TCustomQueryDesigner.GetMasterTables( Index : integer ) : string;
var MIndex : integer;
begin

  Result := '';
  MIndex := Index;

  while MIndex >= 0 do begin
    Result:= Result +','''+(fTables[MIndex] as TCQTable).TableName+'''';
    MIndex := (fTables[MIndex] as TCQTable).MasterIndex;
  end;

  if Result = '' then begin
    Result := ''''+(fTables[Index] as TCQTable).TableName+'''';
  end else begin
  System.Delete(Result,1,1);
  end;

end;

procedure TCustomQueryDesigner.GetRelatedTable(Name, ExcludeTable : string; Node : TTreeNode; MasterIndex : integer );
var Items       : TStringList;
    i           : integer;
    CNode       : ttreenode;
    TableCount,
    ArrayOffset : integer;
    TableDisplayname : string;
    NewTableName : string;
    DetailListIndex : integer;
begin

  Items := TStringlist.create();

  fTableRelations.SQL.Text := Format(SQL_Relations,[UpperCase(GetMasterTables(MasterIndex))]);

  fTableRelations.ParamByName('TableName').DataType := ftString;
  fTableRelations.ParamByName('TableName').ParamType := ptInput;
  fTableRelations.ParamByName('TableName').AsString:=UpperCase(Name);

  with fTableRelations do begin
    prepare;
    Open;
    First;
  end;

  ArrayOffset := fTables.Count;

  while not fTableRelations.Eof do begin
     NewTableName := StringReplace(fTableRelations.FieldByName('MASTER_TABLE').AsString,' ','',[rfReplaceAll]);

     Items.Add(NewTableName);
     TableCount := fTables.Count;

     fTables.Add(TCQTable.Create(NewTableName,
                                 StringReplace(fTableRelations.FieldByName('DETAIL_TABLE').AsString,' ','',[rfReplaceAll]),
                                 fTableRelations.FieldByName('MASTER_INDEX').AsString,
                                 fTableRelations.FieldByName('DETAIL_INDEX').AsString,
                                 TableCount,
                                 MasterIndex,
                                 -1));
     fTableRelations.Next();

  end;

  fTableRelations.Close;

  for i := 0 to Items.Count-1 do begin

   (***********************************)

     TableDisplayname:='';
     DetailListIndex := fTables.TableByName( (fTables[i+ArrayOffset] as TCQTable).DetailTable).ListIndex;

     if fTables.CountOfTableWithSameDetail(Items[i],
                                           (fTables[i+ArrayOffset] as TCQTable).DetailTable,
                                           DetailListIndex )>1 then begin

       fFieldsInIndex.ParamByName('Index').AsString:= UpperCase((fTables[i+ArrayOffset] as TCQTable).DetailIndex);
       fFieldsInIndex.Open();

       while not fFieldsInIndex.eof do begin
         TableDisplayname := TableDisplayname +
                            GetDisplayOptionsForField( (fTables[i+ArrayOffset] as TCQTable).DetailTable,
                                                        StringReplace(fFieldsInIndex.FieldbyName('FIELD_NAME').AsString,' ','',[rfReplaceAll]));
         fFieldsInIndex.next();
       end;

       fFieldsInIndex.Close();

     end;

     if TableDisplayname <> '' then begin
       TableDisplayname := TableDisplayname+' - ';
     end;

   (***********************************)

    CNode := fTreeView.Items.AddChildObject(Node, TableDisplayname+GetDisplayOptionsForTable(Items[i]), nil);

    (fTables[i+ArrayOffset] as TCQTable).NodeIndex := CNode.AbsoluteIndex;

    GetRelatedTable(Items[i],ExcludeTable,CNode,i+ArrayOffset);
  end;

  Items.Free();

end;


procedure TCustomQueryDesigner.JoinTables();
begin

  if Assigned(fTreeView) and (fTreeView.Items.Count > 0) then begin
    DetermineJoins(fTreeView.Items.Item[0]);
  end;

end;


function TCustomQueryDesigner.DetermineJoins( Node : TTreeNode ): boolean;
var i   : integer;
    Tbl : TCQTable;
begin

  Result := FALSE;

  if Node.Count > 0 then begin

    for i:=0 to Node.Count-1 do begin

      Result := DetermineJoins( Node.Item[i] ) or Result;

      Tbl := fTables.TableByNodeIndex(Node.AbsoluteIndex);

      if not Result then begin
        Result := TableHasSelectedFields(Tbl) > 0
      end;

      if Result then begin

        if fSQLSourceTables.IndexOfObject(Tbl)=-1 then begin

          BuildJoinString( Tbl );

        end;

      end;

    end;

  end else begin // last item in tree

    Tbl := fTables.TableByNodeIndex(Node.AbsoluteIndex);

    if TableHasSelectedFields(Tbl) > 0 then begin

      BuildJoinString( Tbl );

      Result := TRUE;
    end;

  end;

end;

procedure TCustomQueryDesigner.BuildJoinString( CQTable : TCQTable );
var
    i           : integer;
    Text        : string;
    MasterIndex : TStringList;
    DetailIndex : TStringList;

begin

  MasterIndex := nil;
  DetailIndex := nil;

  try

    fSQLSourceTables.AddObject(StringReplace( CQTable.TableName,' ','',[rfReplaceAll]),CQTable);

    MasterIndex := TStringList.Create();
    DetailIndex := TStringList.Create();

    IndexFields( CQTable.Index, MasterIndex);
    IndexFields( CQTable.DetailIndex, DetailIndex);

    Text:='';

    if MasterIndex.Count <> DetailIndex.Count then begin
      raise Exception.Create( errDiffFieldCountInIndex );
    end;

    for i := 0 to MasterIndex.Count-1 do begin

      Text := Text + 'Tbl_'+IntToStr(CQTable.MasterIndex)+'.'+DetailIndex[i]+'='+
                     'Tbl_'+IntToStr(CQTable.ListIndex)+'.'+MasterIndex[i];

      if i < MasterIndex.Count-1 then begin
         Text := Text +' AND ';
      end;

    end;

    CQTable.JoinStr := Text;

  finally

    if Assigned(MasterIndex) then begin
      MasterIndex.Free();
    end;

    if Assigned(DetailIndex) then begin
      DetailIndex.Free();
    end;

  end;

end;


function TCustomQueryDesigner.TableHasSelectedFields( CQTable : TCQTable ): integer;
var i : integer;
begin

  Result := 0;

  with CQTable do begin

    for i := 0 to Fields.Count-1 do begin

      Inc(Result,integer((Fields[i] as TCQField).Checked));

    end;

  end;

end;

function TCustomQueryDesigner.BuildQuery(): string;
var i,j, index : integer;
    Tbl : TCQTable;
    SQLSelectTables : TStringList;
begin
  fParams.Clear();
  fSQLText := '';

  SQLSelectTables := TStringList.Create();
  fSQLWhereClause.Clear();
  fSQLSelectFields.Clear();

  for i := 0 to fTables.Count-1 do begin

    Index := fSQLSourceTables.IndexOfObject(fTables[i]);

    if Index > -1 then begin
      Tbl := (fSQLSourceTables.Objects[Index] as TCQTable);

      SQLSelectTables.Add(Tbl.TableName+' Tbl_'+IntToStr(Tbl.ListIndex)+'' );

      if Tbl.JoinStr <> '' then begin
        fSQLWhereClause.Add(Tbl.JoinStr)
      end;

      for j:=0 to Tbl.Fields.Count -1 do begin

        if (Tbl.Fields[j] as TCQField).Checked then begin

          fSQLSelectFields.Add('Tbl_'+IntToStr(Tbl.ListIndex)+'.'+(Tbl.Fields[j] as TCQField).FieldName );
        end;

        if (Tbl.Fields[j] as TCQField).SQLExp<>'' then begin
          fSQLWhereClause.Add((Tbl.Fields[j] as TCQField).SQLExp);

          if (Tbl.Fields[j] as TCQField).FieldConditions[1].HasValue then begin
            fParams.AddObject('a_'+IntToStr((Tbl.Fields[j] as TCQField).fOwnerIndex)+'_'+IntToStr((Tbl.Fields[j] as TCQField).fIndex),
                            (Tbl.Fields[j] as TCQField));
          end;

          if (Tbl.Fields[j] as TCQField).FieldConditions[2].HasValue then begin
            fParams.AddObject('b_'+IntToStr((Tbl.Fields[j] as TCQField).fOwnerIndex)+'_'+IntToStr((Tbl.Fields[j] as TCQField).fIndex),
                            (Tbl.Fields[j] as TCQField));
          end;

        end;

      end;

    end;

  end;

  if fSQLSelectFields.Text <> '' then begin

    if fIncludeFields.Text <> '' then begin
      fSQLSelectFields.Insert(0,DecomposeIncludeFields());
    end;

    fSQLText := 'SELECT';

    for i := 0 to fSQLSelectFields.Count-1 do begin
      fSQLText:=fSQLText+#13+fSQLSelectFields[i];

      if i < fSQLSelectFields.Count-1 then begin
        fSQLText:=fSQLText+',';
      end;

    end;

    fSQLText:=fSQLText+#13+'FROM';

    for i := 0 to SQLSelectTables.Count-1 do begin
      fSQLText:=fSQLText+#13+ SQLSelectTables[i];

      if i < SQLSelectTables.Count-1 then begin
        fSQLText:=fSQLText+',';
      end;
    end;

    if fSQLWhereClause.Text <> '' then begin
      fSQLText:=fSQLText+#13+'WHERE';

      for i := 0 to fSQLWhereClause.Count-1 do begin
        fSQLText:=fSQLText+#13+fSQLWhereClause[i];

        if i < fSQLWhereClause.Count-1 then begin
          fSQLText:=fSQLText+' AND ';
        end;

      end;

    end;

  end;


  Result := fSQLText;
  SQLSelectTables.Free();

end;

procedure TCustomQueryDesigner.ListViewChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var Tbl : TCQTable;
begin

  if (fTreeView.Selected <> nil) and not fUpdating then begin

    tbl:=fTables.TableBynodeIndex(fTreeView.Selected.AbsoluteIndex);
    (Tbl.Fields[Item.Index] as TCQField).Checked := Item.Checked;

  end;

end;

procedure TCustomQueryDesigner.ListViewDblClick(Sender: TObject);
var CQTable : TCQTable;
    CQField : TCQField;
    ClearFlag : boolean;
    Value1, Value2 : TFieldValueExpression;
begin

  if Assigned(fTreeView) then begin

    if fTreeview.Selected <> nil then begin

      CQTable := fTables.TableByNodeIndex(fTreeview.Selected.AbsoluteIndex);

      if fListView.Selected <> nil then begin

        CQField := TCQField(fListView.Selected.Data);

        CQField.GetFieldAsFieldValueExpression(Value1,1);
        CQField.GetFieldAsFieldValueExpression(Value2,2);

        if Assigned(fOnFieldValueRequired) then begin
          ClearFlag := FALSE;
          fOnFieldValueRequired( fListView,
                                 CQTable.TableName,
                                 CQField.FieldName,
                                 CQField.DisplayName,
                                 IBDataTypeToParamType(CQField.DataType),
                                 CQField.StrLength,
                                 CQField.MainBool,
                                 CQField.MainBool2,
                                 Value1,
                                 Value2,
                                 ClearFlag );

          if ClearFlag then begin
            CQField.Expression := '';
            CQField.SQLExp :='';
            fListView.Selected.SubItems[0] := '';
            CQField.FieldConditions[1].HasValue := FALSE;
            CQField.FieldConditions[2].HasValue := FALSE;
          end else begin
            CQField.SetFieldData(Value1.ValueAsText,1);

            if CQField.FieldConditions[1].HasValue then begin
              CQField.FieldConditions[1].Operator := Value1.Operator;
            end;

            if CQField.MainBool2 <> fboNOTASSIGNED then begin
              CQField.SetFieldData(Value2.ValueAsText,2);

              if CQField.FieldConditions[2].HasValue then begin
                CQField.FieldConditions[2].Operator := Value2.Operator;
              end;

            end;

            fListView.Selected.SubItems[0] := CQField.BuildExpression();

          end;

        end;

      end;

    end;

  end;

end;


function TCustomQueryDesigner.SetUpResultQuery( Query : TIBQuery ) : boolean;
var i : integer;
begin

  JoinTables();
  BuildQuery();

  Result := fSQLText <> '';
  if Result then begin
    Query.SQL.Text := fSQLText;

    for i:=0 to fParams.Count-1 do begin
      Query.ParamByName(fParams[i]).DataType := IBDataTypeToParamType((fParams.Objects[i] as TCQField).DataType);
      Query.ParamByName(fParams[i]).ParamType := ptInput;
      Query.ParamByName(fParams[i]).Value := (fParams.Objects[i] as TCQField).GetFieldData(byte(fParams[i][1]='b')+1);
    end;

  end;

end;


procedure TCustomQueryDesigner.SetDisplayNameSource( Value : string );
begin

  if fdnsName <> Value then begin
    fdnsName := Value;
  end;

end;


function TCustomQueryDesigner.GetDisplayNameSource() : string;
begin
  Result := fdnsName;
end;


procedure TCustomQueryDesigner.SetDisplayNameSourceType( Value : TDisplayNameSourceType);
begin

  if fdnsType <> Value then begin

    case fdnsType of

      dnsIniFile : begin
        if Assigned(fIniFile) then begin
          FreeAndNil(fIniFile);
        end;

      end;

      dnsRegistry : begin

        if Assigned(fRegistry) then begin
          FreeAndNil(fRegistry)
        end;

      end;

    end;

    fdnsType := Value;

    case fdnsType of

      dnsIniFile : begin
        fIniFile := TIniFile.Create(fdnsName);
      end;

      dnsRegistry : begin
        fRegistry := TRegistry.Create();
        fRegistry.OpenKey(fdnsname,FALSE);
      end;

    end;

  end;

end;

function TCustomQueryDesigner.GetDisplayNameSourceType() : TDisplayNameSourceType;
begin
  Result := fdnsType;
end;


function TCustomQueryDesigner.GetDisplayOptionsForTable( TableName : string ): string;
begin



  case fdnsType of

    dnsIniFile : begin
      Result  := fIniFile.ReadString(TableName,'DisplayName',TableName);
    end;

    dnsRegistry : begin
      fRegistry.OpenKey(TableName,FALSE);
      Result:=fRegistry.ReadString(TableName);
      fRegistry.CloseKey();
    end;

    dnsIBTable : begin
      // not implemented yet
    end;

    dnsRDBDescription : begin
      // not implemented yet
    end;

  else
    Result := TableName;
  end;

  if Result = '' then begin
    Result := TableName;
  end;

end;


function TCustomQueryDesigner.GetDisplayOptionsForField( TableName, FieldName : string; var Display : boolean ): string;
begin

  Display:= TRUE;

  case fdnsType of

    dnsIniFile : begin
      Result   := fIniFile.ReadString(TableName,FieldName,FieldName);
      Display  := fIniFile.ReadBool(TableName,'D_'+FieldName,TRUE);
    end;

    dnsRegistry : begin
      fRegistry.OpenKey(TableName,FALSE);
      Result:=fRegistry.ReadString(TableName);
      Display:=fRegistry.ReadBool('Display');
      fRegistry.CloseKey();
    end;

    dnsIBTable : begin
      // not implemented yet
    end;

    dnsRDBDescription : begin
      // not implemented yet
    end;

  else
    Result := FieldName;
  end;

  if Result = '' then begin
    Result := FieldName;
  end;

end;

function TCustomQueryDesigner.GetDisplayOptionsForField( TableName, FieldName : string ): string;
var B : boolean;
begin
  Result := GetDisplayOptionsForField( TableName, FieldName , B );
end;

procedure TCustomQueryDesigner.GenereateIniFileStructure( FileName : string ='' );
var Ini : TiniFile;
    i,j : integer;
begin

  if (FileName = '') and (fdnsName ='' ) then begin

    raise Exception.Create('Missing filename. Assign the parameter for GenereateIniFileStructure method or set the DisplayNameSource property');

  end else begin
    if Filename = '' then begin
      FileName := fdnsName;
    end;

    Ini := TiniFile.Create(FileName);

    for i:= 0 to fTables.Count-1 do begin

      Ini.WriteString((fTables[i] as TCQTable).TableName,'DisplayName','');

      if (fTables[i] as TCQTable).Fields.Count = 0 then begin
        PopulateFields(fTables[i] as TCQTable);
      end;

      for j:=0 to (fTables[i] as TCQTable).Fields.Count-1 do begin
        Ini.WriteString((fTables[i] as TCQTable).TableName,
                        ((fTables[i] as TCQTable).Fields[j] as TCQField).FieldName,'');
        Ini.WriteString((fTables[i] as TCQTable).TableName,
                        'D_'+((fTables[i] as TCQTable).Fields[j] as TCQField).FieldName,'');

      end;

    end;
  end;
end;

procedure TCustomQueryDesigner.GenereateRegistryStructure( KeyName : string );
var Reg : TRegistry;
    i,j : integer;
begin

  Reg := TRegistry.Create();

  for i:= 0 to fTables.Count-1 do begin

    Reg.OpenKey(KeyName+'\'+(fTables[i] as TCQTable).TableName,TRUE);
    Reg.WriteString('DisplayName','');

    if (fTables[i] as TCQTable).Fields.Count = 0 then begin
      PopulateFields(fTables[i] as TCQTable);
    end;

    Reg.CloseKey();

    for j:=0 to (fTables[i] as TCQTable).Fields.Count-1 do begin

      Reg.OpenKey(KeyName+'\'+(fTables[i] as TCQTable).TableName+'\'+((fTables[i] as TCQTable).Fields[j] as TCQField).FieldName,TRUE);

      Reg.WriteString('DisplayName','');
      Reg.WriteBool('Display',TRUE);
      Reg.CloseKey();
    end;

  end;

  Reg.CloseKey();
  FreeAndNil(Reg);

end;

procedure TCustomQueryDesigner.AssignDataBaseToQueries();
begin
  fTransaction.DefaultDataBase := fIBDataBase;
  fTableRelations.DataBase     := fIBDataBase;
  fDetailForeignKey.DataBase   := fIBDataBase;
  fFieldsInIndex.DataBase      := fIBDataBase;
  fFieldsForTable.DataBase     := fIBDataBase;
  fResultQuery.DataBase        := fIBDataBase;
end;

procedure TCustomQueryDesigner.SetIBDataBase( Value : TIBDataBase );
begin

  if fIBDataBase <> Value then begin
    fIBDataBase := Value;
    AssignDataBaseToQueries();
  end;

end;

function TCustomQueryDesigner.GetIBDataBase() : TIBDataBase;
begin
  Result := fIBDataBase;
end;


procedure TCustomQueryDesigner.SetAutoSetupListView( Value : boolean );
begin

  if fAutoSetupListView <> Value then begin
    fAutoSetupListView := Value;
  end;

end;


function TCustomQueryDesigner.GetAutoSetupListView() : boolean;
begin
  Result := fAutoSetupListView;
end;


procedure TCustomQueryDesigner.SetUpListView();
begin
  with fListView do begin
    Checkboxes := TRUE;
    with Columns do begin
      Clear();
      Add();
      Add();
      Items[0].Caption := SLBColNameFieldName;
      Items[0].Width := Round(Width*0.33);
      Items[1].Caption := SLBColNameValue;
      Items[1].Width := Round(Width*0.66);
    end;
    ViewStyle := vsReport
  end;
end;


procedure TCustomQueryDesigner.WriteFileHeader( FS : TFileStream );
var _Date : TDate;
begin
  FS.Write(CAHCE_FILE_ID,4);
  _Date:=Date();
  FS.Write( _Date ,sizeof(TDate));

end;

procedure TCustomQueryDesigner.GetSavedQueryList( List : TStrings );
var
    qryFileName : string;
    QueryFile  : TFileStream;
    name : shortstring;
    count : integer;
begin

  qryFileName := fPermanentCacheDir+ChangeFileExt(GetCacheFileName(),'.'+QUERY_FILE_EXTENSION);
  QueryFile := TFileStream.Create(qryFileName, fmOpenRead);

  if CheckCacheFileVersion( QueryFile ) then begin

    while QueryFile.Read(name, SizeOf( shortstring)) = SizeOf(shortstring) do begin
      List.Add(Name);
      QueryFile.Read(count, SizeOf(Integer));
      QueryFile.Seek(count*SizeOf(TQueryValues),soFromCurrent);
    end;

  end;
  QueryFile.Free();
end;


procedure TCustomQueryDesigner.EnumSavedQueries( CallBackProc : TEnumSavedQueries );
var
    qryFileName : string;
    QueryFile  : TFileStream;
    name : shortstring;
    count : integer;
    SectionSize,
    Section : integer;
    Deleted : boolean;


begin

  if Assigned(CallBackProc) then begin

    Section := 0;

    qryFileName := fPermanentCacheDir+ChangeFileExt(GetCacheFileName(),'.'+QUERY_FILE_EXTENSION);
    QueryFile := nil;
    try
      QueryFile := TFileStream.Create(qryFileName, fmOpenRead);

      if CheckCacheFileVersion( QueryFile ) then begin

        QueryFile.Read(count, SizeOf(Integer));
        SectionSize := SizeOf(boolean) + SizeOf(shortstring) + Count*SizeOf(TQueryValues);

        while QueryFile.Size >= QueryFile.Position + SectionSize do begin

          QueryFile.Read( Deleted, SizeOf(boolean) );
          QueryFile.Read( name, SizeOf( shortstring));

          QueryFile.Seek(count*SizeOf(TQueryValues),soFromCurrent);

          if not Deleted then begin
            CallBackProc(Section, Name);
          end;

          inc(Section);
        end;

      end;
    finally
      if Assigned(QueryFile) then begin
        FreeAndNil(QueryFile);
      end;
    end;

  end;

end;

function TCustomQueryDesigner.SeekForDeletedSection( QueryFile : TFileStream ) : boolean;
var
    SectionSize,
    FieldCount     : integer;

    EofReached,
    Deleted : boolean;
begin

  QueryFile.Seek(0,soFromBeginning);

  if CheckCacheFileVersion( QueryFile ) then begin
    EofReached := TRUE;
    Deleted := FALSE;

    QueryFile.Read(FieldCount, SizeOf(Integer));

    SectionSize := SizeOf(boolean) +SizeOf(shortstring) + (FieldCount*SizeOf(TQueryValues));

    while not Deleted and not EofReached do begin

      EofReached := QueryFile.Size >= QueryFile.Position + SectionSize;

      if not EofReached then begin

        QueryFile.Read(Deleted, SizeOf(boolean));

        if not Deleted then begin
          QueryFile.Seek(SectionSize - SizeOf(boolean),soFromCurrent);
        end else begin
          QueryFile.Seek( SizeOf(boolean) * -1 ,soFromCurrent);
        end;

      end;

    end;

    Result := Deleted;

  end else begin

    raise EInvalidFileFormat.Create( errInvalidQFilestructure );

  end;

end;

procedure TCustomQueryDesigner.SaveQuery( qryName : shortstring );
var
    SaveFile  : TFileStream;
    Field            : TCQField;
    outField         : TQueryValues;
    i,j,
    FieldCountInView : integer;
    qryFileName      : string;
    Mode             : word;
    Deleted          : boolean;
begin

  qryFileName := fPermanentCacheDir+ChangeFileExt(GetCacheFileName(),'.'+QUERY_FILE_EXTENSION);

  if FileExists(qryFileName) then begin
    Mode := fmOpenReadWrite;
  end else begin
    Mode := fmCreate;
  end;

  SaveFile := nil;

  try
    SaveFile := TFileStream.Create(qryFileName, Mode);

    if SaveFile.Size = 0 then begin
      WriteFileHeader( SaveFile );
      FieldCountInView := GetFieldCount();
      SaveFile.Write(FieldCountInView,SizeOf(integer));
    end else begin

      if not SeekForDeletedSection(SaveFile) then begin
        SaveFile.Seek(0,soFromEnd);
      end;

    end;

    Deleted := FALSE;
    SaveFile.Write( Deleted, SizeOf(boolean));
    SaveFile.Write( qryName,SizeOf(shortstring));

    for i:= 0 to fTables.Count -1 do begin

      for j:=0 to (fTables[i] as TCQTable).Fields.Count-1 do begin
        Field := ((fTables[i] as TCQTable).Fields[j] as TCQField);

          with Field do begin
            outField.TableID           := i;
            outField.FieldID           := j;
            outField.Checked           := Checked;
            outField.MainBool          := MainBool;
            outField.BoolBetweenFields := MainBool2;
            outField.FieldConditions   := FieldConditions;
          end;

        SaveFile.Write(outField,SizeOf(outField));
      end;

    end;

  finally

    if Assigned(SaveFile) then begin
      FreeAndNil(SaveFile);
    end;

  end;

end;

function TCustomQueryDesigner.PositionToQuery( QueryFile : TFileStream; QueryID : integer; var FieldCount : integer ) : boolean;
var SectionSize,
    CurrentSection : integer;
    EofReached     : boolean;
begin

  if CheckCacheFileVersion( QueryFile ) then begin

    CurrentSection := 0;
    EofReached := FALSE;
    QueryFile.Read(FieldCount, SizeOf(Integer));
    SectionSize := SizeOf(shortstring) + SizeOf(boolean) + (FieldCount*SizeOf(TQueryValues));

    while (CurrentSection < QueryID) and not EofReached do begin

      EofReached := QueryFile.Size >= QueryFile.Position + SectionSize;

      if not EofReached then begin
        QueryFile.Seek(SectionSize,soFromCurrent);
        Inc(CurrentSection);
      end;

    end;

    Result := not EofReached;

  end else begin

    raise Exception.Create( errInvalidQFilestructure );

  end;

end;

procedure TCustomQueryDesigner.DeleteQuery( QueryID : integer );
var qryFileName      : string;
    QueryFile        : TFileStream;
    FieldCountInView : integer;
    Deleted          : boolean;
begin

  qryFileName := fPermanentCacheDir+ChangeFileExt(GetCacheFileName(),'.'+QUERY_FILE_EXTENSION);
  QueryFile := nil;

  try
    QueryFile := TFileStream.Create( qryFileName, fmOpenReadWrite );

    if PositionToQuery( QueryFile,QueryID, FieldCountInView) then begin
      Deleted := TRUE;
      QueryFile.Write(Deleted, SizeOf(Deleted) );
    end;

  finally

    if Assigned(QueryFile) then begin
      FreeAndNil(QueryFile);
    end;

  end;

end;

procedure TCustomQueryDesigner.LoadQuery( QueryID : integer );
var
    LoadFile         : TFileStream;
    qryFileName      : string;
    FieldCountInView : integer;
    outField         : TQueryValues;
    Table            : TCQTable;
    Field            : TCQField;
    i                : integer;
    Name             : shortstring;
    Deleted          : boolean;
begin


  if fTables.Count <> 0 then begin

    qryFileName := fPermanentCacheDir+ChangeFileExt(GetCacheFileName(),'.'+QUERY_FILE_EXTENSION);

    LoadFile := nil;

    try
      LoadFile := TFileStream.Create( qryFileName, fmOpenRead );

      if PositionToQuery(LoadFile,QueryID,FieldCountInView) then begin

        LoadFile.Read(Deleted, SizeOf(boolean));
        LoadFile.Read(Name, SizeOf( shortstring ));

        for i := 1 to FieldCountInView do begin
          LoadFile.Read( outField, SizeOf(outField) );

          if fTables.Count > outField.TableID then begin
            Table := (fTables[outField.TableID] as TCQTable);
            if Table.Fields.Count = 0 then begin
              PopulateFields(Table);
            end;

            if Table.Fields.Count > outField.FieldID then begin
              Field := (Table.Fields[outField.FieldID] as TCQField);

              with Field do begin
                Checked         := outField.Checked;
                MainBool        := outField.MainBool;
                MainBool2       := outField.BoolBetweenFields;
                FieldConditions := outField.FieldConditions;
              end;

              Field.BuildExpression;
            end;

          end;

        end;

      end;

    finally

      if Assigned(Loadfile) then begin
         FreeAndNil(LoadFile);
      end;

    end;

  end else begin

  end;

  if Assigned(fTreeview) and (fTreeView.Items.Count > 0) then begin
    fTreeView.Selected := fTreeView.Items[0];
  end;

end;


(*
 *
 * Cache handling methods
 *
 *)

procedure TCustomQueryDesigner.SetUsePermanentCache( Value : boolean );
begin

  if Value <> fUsePermanentCache then begin
    fUsePermanentCache := Value;
  end;

end;


function TCustomQueryDesigner.GetUsePermanentCache() : boolean;
begin
  Result := fUsePermanentCache;
end;


procedure TCustomQueryDesigner.SetPermanentCacheDir( Value : string );
begin

  if Value <> fPermanentCacheDir then begin
    if Value[Length(Value)]<>'\' then begin
      Value := Value +'\'
    end;

    fPermanentCacheDir := Value;
  end;

end;


function TCustomQueryDesigner.GetPermanentCacheDir() : string;
begin
  Result := fPermanentCacheDir;
end;


procedure TCustomQueryDesigner.ClearPermanentCache();
begin
  ClearCQDCache(fPermanentCacheDir);
end;


function TCustomQueryDesigner.ViewInCache() : boolean;
var CacheFileName : string;
begin

  if fUsePermanentCache then begin
    CacheFileName := GetCacheFileName();
    Result := FileExists(fPermanentCacheDir+CacheFileName);
  end else begin
    Result := FALSE;
  end;

end;


function TCustomQueryDesigner.CheckCacheFileVersion( CacheFile : TFileStream ) : boolean;
var
  VersionInfo : array[0..3] of char;
  _Date       : TDate;
begin

  CacheFile.Read( VersionInfo, 4);
  CacheFile.Read( _Date, SizeOf(TDate) );
  Result := VersionInfo = CAHCE_FILE_ID;

end;


procedure TCustomQueryDesigner.ReadViewFromCache();
var LoadFile    : TFileStream;
    MemStream   : TMemoryStream;
    Size        : longint;
    i,j         : integer;
    TableCount  : integer;
    FieldCount  : integer;

    recTbl      : recTable;
    recFld      : recField;
    Tbl         : TCQTable;

begin

  if Assigned(fTreeView) then begin

    LoadFile  := nil;
    MemStream := nil;

    try
      fTables.Clear;
      fTreeView.Items.Clear();

      LoadFile := TFileStream.Create(fPermanentCacheDir + GetCacheFileName(),fmOpenRead );

      if CheckCacheFileVersion( LoadFile ) then begin

        MemStream := TMemoryStream.Create;


        LoadFile.Read( Size ,SizeOf(longint));
        MemStream.CopyFrom(LoadFile,Size);

        MemStream.Position:=0;
        fTreeView.LoadFromStream(MemStream);

        LoadFile.Read( TableCount ,sizeof(integer));

        for i:= 0 to TableCount - 1 do begin

          LoadFile.Read( recTbl, SizeOf(recTable));

          fTables.Add(TCQTable.Create( recTbl.TableName,
                                       recTbl.DetailTable,
                                       recTbl.Index,
                                       recTbl.DetailIndex,
                                       recTbl.ListIndex,
                                       recTbl.MasterIndex,
                                       recTbl.NodeIndex));

          Tbl := (fTables[fTables.Count-1] as TCQTable);

          LoadFile.Read( FieldCount ,sizeof(integer));

          for j := 0 to FieldCount - 1 do begin

            LoadFile.Read( recFld, SizeOf(recField) );
            Tbl.Fields.Add( TCQField.Create( recFld.FieldName,'',
                                             recFld.DataType,
                                             recFld.StrLength,
                                             recFld.Display,
                                             FALSE,
                                             recFld.OwnerIndex,
                                             recFld.Index));

            (Tbl.Fields[Tbl.Fields.Count-1] as TCQField).GetFieldFromRecord(recFld);
          end;

        end;

        if fTreeView.Items.Count > 0 then begin
          fTreeView.Selected := fTreeView.Items[0];
        end;

      end else begin
        raise EInvalidFileFormat.Create(errInvalidCFilestructure);
      end;

    finally

      if Assigned(MemStream) then begin
        MemStream.Clear();
        FreeAndNil(MemStream);
      end;

      if Assigned(LoadFile) then begin
        FreeAndNil(LoadFile);
      end;

    end;

  end else begin
  end;

end;


function TCustomQueryDesigner.GetCacheFileName() : string;
begin
  Result := fTableName + CACHE_FILE_NAME_SEPARATOR + fDetailTableName + '.' + CACHE_FILE_EXTENSION;
end;


procedure TCustomQueryDesigner.WriteViewToCache();
var
    SaveFile    : TFileStream;
    MemStream   : TMemoryStream;
    _Date       : TDate;
    Size        : longint;
    FieldCount,
    TableCount,
    i,j         : integer;
    Tbl         : TCQTable;
    recTbl      : recTable;
    recFld      : recField;
begin

  SaveFile  := nil;
  MemStream := nil;

  if Assigned(fTreeView) and (fTables.Count <> 0) then begin

    try

      SaveFile := TFileStream.Create(fPermanentCacheDir + GetCacheFileName(),fmCreate);
      MemStream := TMemoryStream.Create;

      //**  CacheFile Header **//
      SaveFile.Write(CAHCE_FILE_ID,4);
      _Date:=Date();
      SaveFile.Write( _Date ,sizeof(TDate));
      //***************************

      //** write out the TreeView **//
      fTreeView.SaveToStream(MemStream);
      Size := MemStream.Size;
      SaveFile.Write(size,sizeof(longint));
      MemStream.Position:=0;
      SaveFile.CopyFrom(MemStream,size);

      //** write Tables & Fields **//
      TableCount := fTables.Count;
      SaveFile.Write(TableCount,sizeof(integer));

      for i := 0 to TableCount-1 do begin

        Tbl := (fTables[i] as TCQTable);
        Tbl.GetTableAsRecord(recTbl);
        SaveFile.Write(recTbl,sizeof(recTable));
        FieldCount := Tbl.Fields.Count;
        SaveFile.Write(FieldCount,SizeOf(Integer));

        for j:= 0 to FieldCount-1 do begin
          (Tbl.Fields[j] as TCQField).GetFieldAsRecord(recFld);
          SaveFile.Write(recFld,sizeof(recField));
        end;

      end;

    finally

      if Assigned(MemStream) then begin
        MemStream.Clear();
        FreeAndNil(MemStream);
      end;

      if Assigned(SaveFile) then begin
        FreeAndNil(SaveFile);
      end;

    end;

  end else begin
    raise Exception.Create(ClassName+': Can not write view to cache without assigned TreeView or without generated view.');
  end;

end;


function TCustomQueryDesigner.TableNameByID( ID : integer ) : string;
begin
  Result := (fTables[ID] as TCQTable).TableName;
end;

function TCustomQueryDesigner.FieldNameByID( TableID, FieldID : integer ) : string;
begin
  Result := ((fTables[TableID] as TCQTable).Fields[FieldID] as TCQField).FIeldName;
end;

function TCustomQueryDesigner.FieldDisplayNameByID( TableID, FieldID : integer ) : string;
begin
  Result := ((fTables[TableID] as TCQTable).Fields[FieldID] as TCQField).DisplayName;
end;

function TCustomQueryDesigner.GetField( TableIndex, FieldIndex : integer ) : TCQField;
begin
  Result := ((fTables[TableIndex] as TCQTable).Fields[FieldIndex] as TCQField);
end;

function TCustomQueryDesigner.SetFieldValue( TableID,
                                             FieldID : integer;
                                             MainBool,
                                             BoolBetweenFields : TFieldBoolOperators;
                                             FieldLowValue,
                                             FieldHighValue : TFieldValueExpression) : integer;
var
   CQField : TCQField;
begin

  Result := 0;
  CQField := GetField( TableID, FieldID );
  CQField.MainBool  := MainBool;
  CQField.MainBool2 := BoolBetweenFields;

  if FieldLowValue.HasValue then begin
    CQField.SetFieldData(FieldLowValue.ValueAsText,1);

    if not CQField.FieldConditions[1].Hasvalue then begin
      Result := 1;
    end;

  end;

  if FieldHighValue.HasValue then begin
    CQField.SetFieldData(FieldHighValue.ValueAsText,2);

    if not CQField.FieldConditions[2].Hasvalue then begin
      Result := 2;
    end;

  end;

end;

procedure TCustomQueryDesigner.SetIncludeFields( Value : TStrings );
begin

  if fIncludeFields.Text <> Value.Text then begin
    fIncludeFields.BeginUpdate;
    try
      fIncludeFields.Assign(Value);
    finally
      fIncludeFields.EndUpdate;
    end;
  end;

end;

function TCustomQueryDesigner.DecomposeIncludeFields() : string;
var i, p : integer;

begin

  Result :='';

  for i := 0 to fIncludeFields.Count-1 do begin

    if fIncludeFields[i] <> '' then begin
      p := Pos('=',fIncludeFields[i]);

      if p <> 0 then begin

        Result := Result + fTableName+'.'+Copy(fIncludeFields[i],1,p-1) + ' "' +
                  Copy(fIncludeFields[i],p+1,Length(fIncludeFields[i])-p)+'"';

        if i < fIncludeFields.Count-1 then begin
          Result := Result +',';
        end;

      end;

    end;

  end;

end;

function TCustomQueryDesigner.GetFieldCount() : integer;
var i : integer;
begin

  Result := 0;

  for i := 0 to fTables.Count-1 do begin

    if (fTables[i] as TCQTable).Fields.Count = 0 then begin
      PopulateFields((fTables[i] as TCQTable));
    end;

    inc(Result,(fTables[i] as TCQTable).Fields.Count);

  end;

end;


procedure Register;
begin
  RegisterComponents('InterBase', [TCustomQueryDesigner]);
end;

end.
